﻿Type=Service
Version=2.52
@EndOfDesignText@
#Region  Service Attributes 
	#StartAtBoot: False
#End Region

Sub Process_Globals
	'These global variables will be declared once when the application starts.
	'These variables can be accessed from all modules.
	Dim Work_Str_Next_Start	As String

End Sub
Sub Service_Create
	Rutinas.Write_Log(Main.SysLogEnable,"Service.Work","Service_Create")
End Sub

Sub Service_Start (StartingIntent As Intent)
	Dim lc_Work_Time	As Int
	Dim lc_Minutes		As Long
	Dim lc_Current_Hour	As Int
	Dim lc_Next_Start	As Long
	Dim lcSqlComando	As String
	Dim Notification_Tel As Notification
	'
	Rutinas.Write_Log(Main.SysLogEnable,"Service.Work","Service_Start")
	Main.Phone_Status.PartialLock
	'
	lc_Next_Start		= DateTime.Now + (Main.SysWorkTime * DateTime.TicksPerMinute)
	lc_Current_Hour		= DateTime.GetHour(DateTime.Now)
	Work_Str_Next_Start	= Rutinas.Get_Format_Date(lc_Next_Start, Main.SysFormatoFecha)
	'
	If lc_Current_Hour >= Main.SysWorkBeginHour AND lc_Current_Hour <= Main.SysWorkEndHour Then
		'
		' Cancel previos schedule (if exists)
		CancelScheduledService("")
		'
		Log("Next Schedule : " & Work_Str_Next_Start)
		Rutinas.Write_Log(Main.SysLogEnable,"Service.Work","Next Schedule : " & Work_Str_Next_Start)
		'
		Try
			StartServiceAt("", lc_Next_Start, True)
		Catch
			Log("Error in Schedule")
			Rutinas.Write_Log(Main.SysLogEnable,"Service.Work","Error in Schedule " & LastException.Message)
		End Try
	Else
		Rutinas.Write_Log(Main.SysLogEnable,"Service.Work","Do Not Schedule")
		Rutinas.Write_Log(Main.SysLogEnable,"Service.Work","Actual Time :" & NumberFormat2(lc_Current_Hour,1,0,0,False))
		Rutinas.Write_Log(Main.SysLogEnable,"Service.Work","SysWorkBeginHour :" & NumberFormat2(Main.SysWorkBeginHour,1,0,0,False))
		Rutinas.Write_Log(Main.SysLogEnable,"Service.Work","SysWorkEndHour :" & NumberFormat2(Main.SysWorkEndHour,1,0,0,False))
	End If
	'
	Check_Running_Programs
	'
	StopService("")
End Sub

Sub Check_Running_Programs
	Dim sb As StringBuilder
	Dim Phone1 As Phone
	Dim lcSqlComando As String
	Dim lcStrFecha As String
	'
	Log("Service.Work.Check_Running_Programs --- Begin")
	'
	sb.Initialize
	Phone1.Shell( "ps", Null, sb, Null)
	Main.GlbInfo	= sb.ToString
	'
	lcStrFecha	= NumberFormat2(DateTime.GetYear(DateTime.Now),4,0,0,False) & "-" & _
					NumberFormat2(DateTime.GetMonth(DateTime.Now),2,0,0,False) & "-" & _
					NumberFormat2(DateTime.GetDayOfMonth(DateTime.Now),2,0,0,False) & " " & _
					NumberFormat2(DateTime.GetHour(DateTime.Now),2,0,0,False) & ":" & _
					NumberFormat2(DateTime.GetMinute(DateTime.Now),2,0,0,False) & ":" & _
					NumberFormat2(DateTime.GetSecond(DateTime.Now),2,0,0,False)
	'
	lcSqlComando = "INSERT INTO sg_t_data (fecha_hora, info) values (" & _
									"^" & lcStrFecha  & "^, " & _
									"^" & Main.GlbInfo & "^)"
	lcSqlComando	= lcSqlComando.Replace("^", Main.GlbComillas)
	'
	If Main.DataBase.IsInitialized = True Then
		Try
			Main.DataBase.ExecNonQuery(lcSqlComando)
		Catch
			Log (lcSqlComando)
			Log ("Work.Check_Running_Programs ERROR: " & LastException.Message)
		End Try
	Else
		Log (lcSqlComando)
		Log ("Work.Check_Running_Programs --- Database is NOT open")
	End If
	'
	Log("Service.Work.Check_Running_Programs --- End")
End Sub

Sub Service_Destroy
	Rutinas.Write_Log(Main.SysLogEnable,"Service.Work","Service_Destroy")
End Sub
